	;PN	MON	

;******************************
;* MONITORPROGRAMM            *
;*                            *
;* V2.1 20.12.83              *
;* ROM-TEIL                   *
;******************************

	cpu	z80
h              function x,(x>>8)&255
l              function x, x&255


	ORG	0F000H	

;SPRUNGTABELLE:

START:	JP	BEGIN	
	JP	CI			;TASTATUR
	JP	RI			;LOCHBANDLESER
	JP	COE			;BILDSCHIRM
	JP	POE			;LOCHBANDSTANZER

	JP	LOE			;DRUCKER
	JP	CSTS			;KONSOLSTATUS
	JP	CRI			;CASSETTENEINGABE
	JP	CPOE			;CASSETTENAUSGABE
	JP	MEMSI			;SPEICHERBEREICH
RSTAR:	JP	MAIN			;RESTART MONITOR
	JP	EXT			;MONITOR FUNKTIONEN
	DW	FINA			;FUER EXTERN


BEGIN:	LD	SP,STACK	
	LD	HL,ATAB			;GERAETEZUWEISUNG
	LD	DE,MSIZE		;INITIALISIEREN
	LD	BC,35			;SPRUNGTABELLE INS RAM LADEN
	LDIR		
	CALL	PRINT			;MELDUNG AUSGEBEN
	DB	CLS	
	DB	" H.MON V2.1 12/83"	
	DB	NL	
	DB	0	
	CALL	CINIT			;KASSETTENPORT INIT
	CALL	RINIT			;LESERPORT INIT
	CALL	MEMCH			;RAMTEST
	LD	(MSIZE),HL	
	JR	MAIN	


;******************************
;* MAIN                       *
;******************************


ERROR:	CALL	PRINT	
	DB	"ILLEGAL COMMAND"	
	DB	0	

;BEFEHLSZEILE EINGEBEN UND PROGRAMM ANSPRINGEN

MAIN:	LD	SP,STACK		;NEU LADEN
	CALL	INL			;EINGABE BEFEHLSZEILE
	CALL	FNEXT			;SPACE AUSBLENDEN
	JR	C, MAIN			;NUR BEI CR
	LD	(TXTPT),DE	
	LD	HL,START-1000H		;SUCHBEGINN
	LD	BC,0FFFFH		;64K DURCHSUCHEN
MAIN1:	LD	A,L(HEAD)	
	CPIR				;NACH ED SUCHEN
	JR	NZ, ERROR		;FEHLER
	LD	A,H(HEAD)		;FOLGT FF?
	CP	A, (HL)	
	JR	NZ, MAIN1		;NEIN
	LD	DE,(TXTPT)	
MAIN2:	LD	A,(DE)			;VERGLEICHEN
	INC	HL	
	INC	DE	
	DEC	BC	
	CP	A, (HL)	
	JR	Z, MAIN2		;GLEICH
	CP	A, ' '			;TEST TRENNZEICHEN/CR
	JR	Z, MAIN3	
	CP	','	

	JR	Z, MAIN3	
	CP	A, CR	
	JR	NZ, MAIN1		;WEITERSUCHEN
;EVT.DOCH KEIN BEFEHL?
MAIN3:	XOR	A			;TEST RAHMEN
	DEC	HL	
	PUSH	BC	
	LD	BC,8	
	CPIR		
	POP	BC	
	JR	NZ, MAIN1	
;HL ZEIGT JETZT AUF 1.BEFEHL
;DE ZEIGT JETZT AUF 1.ARGUMENT
	LD	BC,MAIN			;RUECKSPRUNG
	PUSH	BC	
	JP	(HL)			;SPRUNG ZUM PROGRAMM


;EINZELNE ARGUMENTE HOLEN

GFINA:	CALL	FNEXT			;FILENAME
	LD	HL,FINA	
	LD	B,8	
GFIN1:	CALL	FNEXT	
	JR	Z, GFIN2		;WEIL TRENNZEICHEN
	LD	(HL),A	
	INC	HL	
	INC	DE	
	DJNZ	GFIN1	
GFIN3:	CALL	FNEXT			;UEBERFLUESSIGE ZEICHEN IGNORIEREN

	RET	Z	
	INC	DE	
	JR	GFIN3	
GFIN2:	LD	(HL),' '		;MIT SPACE AUFFUELLEN
	INC	HL	
	DJNZ	GFIN2	
NICHT:	RET		

GFITY:	CALL	FNEXT			;FILETYP/OPTION
	LD	HL,FITY	
	LD	B,2	
	CP	A, '@'	
	JR	NZ, GFIN2	
	INC	DE	
	JR	GFIN1	

GCOM:	CALL	FNEXT			;ZUSAETZL.ANGABEN
	LD	HL,DATA	
	LD	B,16	
	CP	A, ';'
	JR	NZ, GFIN2	
GCOM1:	INC	DE	
	LD	A,(DE)	
	CP	A, CR	
	JR	Z, GFIN2	
	LD	(HL),A	
	INC	HL	
	DJNZ	GCOM1	
	RET		


;ASCII -> HEX

INHEX:	LD	A,' '			;HEX VON TASTATUR HOLEN
	CALL	CO	
	CALL	INL00	

ASHEX:	CALL	FNEXT			;KONVERTIEREN
	CALL	CNVBN	
	LD	A,(DE)	
	RET	C			;KEIN HEX
	PUSH	BC	
	LD	HL,0	
ASH1:	LD	A,(DE)	
	CALL	CNVBN	
	JR	C, ASH4	
ASH3:	ADD	HL,HL			;SCHIEBEN
	ADD	HL,HL	
	ADD	HL,HL	
	ADD	HL,HL	
	LD	B,0	
	LD	C,A	
	ADD	HL,BC	
	INC	DE	
	JR	ASH1	
ASH4:	POP	BC	
	XOR	A	
	RET		

CNVBN:	SUB	30H	
	RET	C	

	CP	A, 10	
	CCF		
	RET	NC	
	CP	A, 11H	
	RET	C	
	CP	A, 17H	
	CCF		
	RET	C	
	SUB	7	
	RET		


;OUTHEX
;WANDELT HEX=>ASCII
;OUTH GIBT BYTE <A> AUS

OUTH:	PUSH	AF	
	RRA				;SCHIEBEN
	RRA		
	RRA		
	RRA		
	CALL	OUTH1	
	POP	AF	
OUTH1:	PUSH	AF	
	AND	A, 00001111B	
	ADD	A, 030H	
	CP	A, 03AH	
	JR	C, OUTH2	
	ADD	A, 07	
OUTH2:	CALL	CO	

	POP	AF	
	RET		

;OUTHL GIBT WORT <HL> AUS

OUTHL:	PUSH	AF	
	LD	A,H	
	CALL	OUTH	
	LD	A,L	
	CALL	OUTH	
	POP	AF	
	RET		

FNEXT:	LD	A,(DE)	
	CP	A, ' '	
	JR	NZ, FNEX3	
FNEX1:	INC	DE	
	LD	A,(DE)	
	CP	A, ' '	
	JR	Z, FNEX1		;SPACE AUSBLENDEN
	CP	CR	
	JR	Z, FNEX4	
FNEX2:	XOR	A	
	LD	A,(DE)	
	RET		
FNEX3:	CP	A, CR	
FNEX4:	SCF		
	RET	Z	
	CCF		
	CP	','	

	INC	DE	
	JR	Z, FNEX2	
	OR	A	
	DEC	DE	
	RET		

;PRINT GIBT ZEICHENKETTE BIS 0 AUS

PRINT:	EX	(SP),HL	
PR1:	LD	A,(HL)	
	INC	HL	
	OR	A			;PRINT-ENDE?
	JR	Z, PR2			;JA
	CALL	CO	
	JR	PR1	
PR2:	EX	(SP),HL	
	RET		

;BEFEHLSZEILEN-EINGABE

INL:	CALL	PRINT	
	DB	NL	
	DB	26H			;PROMT
	DB	0	
INL00:	LD	DE,TXTBU	
	LD	B,BULEN	
INL1:	CALL	CI	
	CP	A, ERASE		;ZEILE LOESCHEN
	JR	Z, INL	
	CP	A, CURL			;BACKSTEP

	JR	Z, INL3	
	CP	A, CR			;RETURN TASTE?
	JR	Z, INL2	
	CP	A, 20H	
	JR	C, INL1			;NICHT DARSTELLBARES ZEICHEN
	LD	(DE),A	
	CALL	CO	
	INC	DE	
	DJNZ	INL1			;WEITER
INL3:	LD	A,B			;BACKSTEP
	CP	A, BULEN	
	JR	Z, INL1	
	DEC	DE	
	INC	B	
	CALL	PRINT	
	DB	CURL	
	DB	" "	
	DB	CURL	
	DB	0	
	JR	INL1	
INL2:	LD	(DE),A			;CR
	LD	A,NL			;NEUE ZEILE
	CALL	CO	
	LD	DE,TXTBU		;ADR. TEXTPUFFER
	RET		


;******************************
;* MEMORY                     *
;******************************


;ALLE BEFEHLE MIT ! ENTFALLEN BZW ZUSAETZLICH BEI 80*24 CRT

	DW	HEAD	
	DB	"MEMORY"	
	NOP		
	CALL	GFITY			;!
	CALL	ASHEX	
MEMO1:	JR	C, MEM	
	LD	(ARG1),HL	
MEM:	CP	A, 'Q'	
	RET	Z	
	LD	A,CLS			;BILDSCHIRM LOESCHEN
	CALL	CO	
	LD	A,(FITY)		;!
	CP	A, 'A'			;!
	LD	A,'H'			;MODE HEX
	JR	NZ, MEMO0 		;!
	OR	80H			;!
MEMO0:	LD	(MEMMO),A	
MEMO:	LD	HL,(ARG1)	
	LD	(ARG2),HL		;ARG2=ARG1
;AUSGABE
MEM1:	LD	A,HOME	
	CALL	CO			;CRT HOME
	LD	A,(MEMMO)		;MODE AUSGEBEN
	RES	7,A			;!
	CALL	CO	
	CALL	PRINT	
	DB	"  CURSOR:"	

	DB	0	
MEM2:	LD	HL,(ARG2)	
	LD	A,L			;MODULO RECHNEN
	AND	A, -MEMB	
	LD	L,A	
	LD	(ARG2),HL		;ADR 1.BYTE
	EX	DE,HL			;DE=BEGINN
	LD	HL,(ARG1)		;CURSOR
	CALL	OUTHL			;AUSGEBEN
	LD	A,NL	
	CALL	CO	
	SBC	HL,DE	
	INC	L			;DISTANZ ZUM CURSOR
	LD	A,(MEMMO)	
	LD	H,A			;MODE
	LD	B,MEML			;ZEILENANZAHL
MEM3:	PUSH	BC			;RETTEN
	PUSH	DE			;BEG.
	BIT	7,H			;! ASCII AUSGABE?
	JR	Z, MEM31		;! JA
	EX	DE,HL			;SONST ADRESSE AUSGEBEN
	CALL	OUTHL	
	EX	DE,HL	
	CALL	PRINT	
	DB	"  "	
	DB	0	
MEM31:	LD	B,MEMB			;BYTEZAEHLER LADEN
MEM4:	LD	A,(DE)			;AUSGABE HEX
	INC	DE	
	CALL	OUTH			;BYTE AUSGEBEN

	DEC	L			;CURSOR SETZEN?
	LD	A,' '	
	JR	NZ, MEM5		;NEIN
	XOR	A			;CODE FUER CURSOR
MEM5:	CALL	CO			;SPACE ODER CURSOR AUSGEBEN
	DJNZ	MEM4			;WEITER
	BIT	7,H			;! ASCII AUSGABE?
	JR	Z, MEM51		;! JA
;LD	A,' '	;!
;CALL	CO	;!
	INC	SP	
	INC	SP	
	JR	MEM71	
MEM51:	LD	B,MEMB			;ZAEHLER
	POP	DE	
MEM6:	LD	A,(DE)			;ASCII AUSGEBEN
	INC	DE	
	AND	A, 7FH			;BIT 7 LOESCHEN
	CP	A, ' '			;TEST NICHT DARSTELLBAR?
	JR	NC, MEM7		;DOCH
	LD	A,'.'			;ANSONSTEN PUNKT AUSGEBEN
MEM7:	CALL	CO	
	DJNZ	MEM6			;WEITER
MEM71:	BIT	7,H	
	JR	Z, MEM72	
	LD	A,NL	
	CALL	CO			;NEUE ZEILE
MEM72:	POP	BC	
	DJNZ	MEM3			;ZEILENZAHLER
;EINGABE

	RES	7,H	
	LD	A,H			;MODE
	CP	A, 'Q'	
	JR	NZ, MEM73	
	CALL	INHEX			;NEUE ADRESSE
	JP	MEMO1	
MEM73:	PUSH	DE			;ENDADR.+1 MERKEN
	LD	E,H			;MODE FUER SPAETER
	LD	D,2			;TETRADEN BYTEEINGABE
MEM8:	CALL	CI			;ZEICHEN VON TASTATUR HOLEN
	CP	A, ESC			;UMSCHALTUNG HEX<==>ASCII EINGABE
	JR	NZ, MEM10	
MEM81:	LD	A,'H'	
	CP	A, E			;VERGLEICH MIT MODE
	JR	NZ, MEM9		;H ==>MODE
	LD	A,'A'	
MEM9:	LD	E,A			;!
	LD	A,(MEMMO)		;!
	AND	A, 80H			;!
	OR	E			;!
MEM91:	LD	(MEMMO),A	
	POP	DE			;KORR.
	JP	MEM1	
MEM10:	LD	BC,-MEMB		;INC FUER CURSOR
	CP	A, CURU			;HOCH
	JR	Z, MEM15	
	LD	C,-1			;BC=-1
	CP	A, CURL			;LINKS
	JR	Z, MEM15	
	INC	BC	

	INC	BC			;BC=1
	CP	A, CURR			;RECHTS
	JR	Z, MEM15	
	LD	C,MEMB	
	CP	A, CURD			;RUNTER
	JR	Z, MEM15	
	CP	A, 'Q'			;QUIT?
	JR	Z, MEM9	
;RAM BESCHREIBEN
MEM11:	LD	L,A			;ZEICHEN RETTEN
	LD	A,E			;MODE
	CP	A, 'A'			;ASCII EINGABE?
	LD	A,L	
	JR	Z, MEM14		;JA
; HEX EINGABE
	CALL	CNVBN	
	JR	C, MEM8			;KEIN HEX,NEUE EINGABE
	LD	HL,ARG3			;HILFSZELLEN
	RLD		
	DEC	D			;TETRADENZAEHLER
	JR	NZ, MEM8		;NAECHSTES ZEICHEN
MEM13:	LD	A,(ARG3)		;NEUES BYTE
MEM14:	LD	HL,(ARG1)		;CURSOR
	LD	(HL),A			;=>RAM
	CP	A, (HL)			;ANGEKOMMEN?
	JR	NZ, MEM19		;NEIN,RAM FEHLER
	LD	C,1			;BC=1;ADR INC
MEM15:	POP	DE			;ENDE+1
	LD	HL,(ARG1)		;CURSOR
	ADD	HL,BC			;CURSOR+INC

	LD	(ARG1),HL		;NEUER CURSOR
	BIT	7,B			;CURSOR RICHTUNG
	JR	Z, MEM16		;ADDITION
	EX	DE,HL			;DE=CURSOR
	INC	DE	
	LD	HL,(ARG2)		;ANFANG
MEM16:	OR	A	
	SBC	HL,DE			;ANF-CURS,CURS-ENDE
	JR	Z, MEM17	
	JP	M, MEM1	
MEM17:	DEC	C			;C=1?
	JR	NZ, MEM18	
	LD	C,MEMB-1	
MEM18:	INC	C	
	LD	HL,(ARG2)		;NEUEN ANFANG BERECHNEN
	ADD	HL,BC	
	LD	(ARG2),HL	
	JP	MEM1	
MEM19:	CALL	PRINT	
	DB	CLS	
	DB	"RAM ERROR "	
	DB	0	
	POP	DE	
	JP	MEM2	

;******************************
;* MOVE                       *
;******************************

	DW	HEAD	

	DB	"MOVE"	
	NOP		
	CALL	ASHEX	
	JP	C, ERROR	
	LD	(ARG1),HL	
	CALL	ASHEX	
	JP	C, ERROR	
	LD	(ARG2),HL	
	CALL	ASHEX	
	JP	C, ERROR	
	LD	B,H	
	LD	C,L	
	LD	HL,(ARG1)	
	LD	DE,(ARG2)	
MOVE:	PUSH	HL	
	XOR	A	
	EX	DE,HL	
	SBC	HL,DE			;ENDE-ANF=ANZAHL
	INC	HL	
	LD	D,B	
	LD	E,C			;DE=ZIEL
	LD	B,H	
	LD	C,L			;BC=LAENGE
	POP	HL			;HL=QUELLE
	PUSH	HL	
	OR	A			;CY=0
	SBC	HL,DE			;MOVE-RICHTUNG
	POP	HL	
	JR	C, MOVE1	
	LDIR				;VORWAERTS UMLADEN


	JR	MOVE2	
MOVE1:	DEC	BC	
	ADD	HL,BC	
	EX	DE,HL	
	ADD	HL,BC	
	EX	DE,HL	
	INC	BC	
	LDDR		
MOVE2:	CALL	CI			;QUIT/MEM
	LD	HL,(ARG1)	
	JP	MEMO1	


;******************************
;* LOAD                       *
;******************************

;D7=1.LESEN,D6=UEBERLESEN
;D5=BLOCK WAR FALSCH,D4=ALLES KORRIGIERT

	DW	HEAD	
	DB	"LOAD"	
	NOP		
LDEXT:	CALL	GFINA	
	CALL	GFITY	
	CALL	ASHEX	
	JR	NC, LOAD	
	LD	HL,0			;KEIN OFFSET
LOAD:	PUSH	HL	
	POP	IY	

	CALL	CINIT	
	LD	HL,(FITY)		;OPTION
	LD	E,0			;E=FEHLER,D=KORREKTURZAHLER
	EXX		
LOD0:	LD	D,80H			;1.LESEN
LOD1:	BIT	7,D	
	JP	Z, LOD12		;FILE NICHT LESBAR
	EXX		
	LD	D,0	
	EXX		
LOD2:	CALL	LOD14			;SYNCHRONISIEREN
	CP	A, NL	
	JR	NZ, LOD3	
	CALL	CRI	
LOD3:	CP	A, SOH	
	JR	NZ, LOD2		;KEIN SOH
	XOR	A	
	LD	C,A			;PRUEFSUMME=0
	LD	E,A			;BLOCKZAHLER
	LD	HL,FINA	
	LD	B,8	
LOD4:	CALL	CRI			;FILENAME VERGLEICHEN
	CP	A, (HL)	
	JR	NZ, LOD1		;NICHT GLEICH
	INC	HL	
	ADD	A, C	
	LD	C,A	
	DJNZ	LOD4	
	LD	B,24			;KOPF LADEN
	BIT	7,D			;1.LESEN

	JR	NZ, LOD5		;JA
	SET	6,D			;2.LESEN,KOPF UEBERLESEN
LOD5:	CALL	LOD16			;BLOCK LESEN
	JR	Z, LOD51		;KOPF RICHTIG
	BIT	7,D	
	JR	NZ, LOD0	
LOD51:	BIT	7,D	
	JR	Z, LOD6			;2.LESEN
	CALL	PRINT	
	DB	NL	
	DB	"FILE FOUND "	
	DB	0	
	PUSH	IY	
	POP	BC			;OFFSET
	LD	HL,(ARG1)	
	ADD	HL,BC	
	LD	(ARG1),HL	
	LD	HL,(ARG2)	
	ADD	HL,BC	
	LD	(ARG2),HL	
	LD	A,B	
	OR	C	
	JR	Z, LOD6			;OFFSET=O
	XOR	A	
	LD	(FITY),A		;AUTOSTART UNTERDRUECKEN
;DATENBLOECKE LESEN
LOD6:	LD	IX,DATA	
	LD	HL,(ARG1)		;ANFANGSADR
LOD7:	CALL	LOD14	
	CP	A, EOT	

	JP	Z, LOD12	
	CP	A, ETX			;ENDE?
	JR	Z, LOD10		;JA
	CP	A, GS	
	JR	NZ, LOD7		;KEIN RICHTIGER BLOCKANFANG
	LD	C,0	
	CALL	CRI			;BLOCKLAENGE
	LD	B,A	
	LD	C,A	
	RES	5,D	
	BIT	7,D	
	JR	NZ, LOD8		;1.LESEN
	SET	6,D			;FUER UBERLESEN,2.LESEN
	BIT	4,D	
	JR	NZ, LOD8		;ALLES KORR.
	PUSH	DE	
	LD	A,D	
	AND	A, 0FH	
	LD	D,(IX+1)	
;WAR BLOCK SCHON FALSCH
	CP	A, D	
	POP	DE	
	JR	NZ, LOD8		;NEIN
	LD	A,(IX)	
	CP	A, E	
	JR	NZ, LOD8		;NEIN
	INC	IX	
	INC	IX	
	EXX		
	DEC	D			;KORREKTURZAEHLER-1

	EXX		
	JR	NZ, LOD71		;ALLES KORRIGIERT?
	SET	4,D			;KEINE FALSCHEN BLOECKE MEHR
LOD71:	RES	6,D			;FREIGABE RAM SCHREIBEN
	SET	5,D			;KORREKTURFLAG
LOD8:	CALL	LOD16			;BLOCK LESEN
	JR	Z, LOD9			;PRUEFSUMME OK
	BIT	5,D			;WURDE BLOCK EBEN KORRIGIERT?
	JR	NZ, LOD12		;JA,FILE NICHT LESBAR
	BIT	7,D			;NEIN
	JR	Z, LOD9			;FEHLER IGNORIEREN
	EXX		
	INC	D	
	LD	A,D	
	EXX				;KORREKTURZAEHLER+1
	CP	A, 8	
	JP	Z, LOD0			;ZU VIELE FEHLER,NOCHMAL VERSUCHEN
	LD	(IX+1),D		;BLOCKNR. ABLEGEN
	RES	7,(IX+1)		;FLAG LOESCHEN
	LD	(IX+0),E	
	INC	IX			;ERRORPOINTER
	INC	IX	
LOD9:	INC	DE			;BLOCKZAEHLER+1
	JR	LOD7	
;ETX BEHANDLUNG
LOD10:	LD	A,D	
	AND	A, 80H			;ZAHLER LOESCHEN,1/2-FLAG NICHT
	LD	D,A	
	DEC	HL			;ENDADR.-1
	LD	BC,(ARG2)	

	SBC	HL,BC			;STIMMT ENDADR.?
	JP	NZ, LOD1		;NEIN
	EXX		
	LD	A,D	
	OR	A			;TRATEN FEHLER AUF?
	JR	Z, LOD11		;NEIN
	EXX		
	LD	D,L			;2.LESEN
	JP	LOD2	
LOD11:	CALL	LOD13			;FEHLERAUSGABE
	LD	A,(FITY)	
	CP	A, 'P'	
	RET	NZ	
	LD	A,L	
	CP	A, 'Q'
	RET	Z	
	LD	HL,(ARG3)	
	JP	(HL)			;AUTOSTART
LOD12:	EXX		
	CALL	PRINT	
	DB	" BAD FILE "	
	DB	0	
LOD13:	LD	A,E	
	OR	A	
	RET	Z	
	CALL	OUTH	
	CALL	PRINT	
	DB	" ERRORS"	
	DB	0	
	RET		

;SYNCHRONISIEREN
LOD14:	CALL	CRI	
	INC	A	
	JR	NZ, LOD14	
LOD15:	CALL	CRI	
	CP	A, 0FFH	
	JR	Z, LOD15	
	RET		
;BLOCK LESEN
LOD16:	CALL	CRI	
	BIT	6,D	
	JR	NZ, LOD17		;UEBERLESEN
	LD	(HL),A	
LOD17:	ADD	A, C	
	LD	C,A	
	INC	HL	
	DJNZ	LOD16	
	CALL	CRI			;PRUEFSUMME
	ADD	A, C	
	RES	6,D			;PRUEFSUMME OK
	RET	Z	
	EXX		
	INC	E	
	EXX				;FEHLERZAHLER+1
	RET		

;******************************
;* SAVE                       *
;******************************


	DW	HEAD	
	DB	"SAVE"	
	NOP		
SAEXT:	CALL	GFINA			;FILENAME HOLEN
	CALL	GFITY			;FILETYP
	CALL	ASHEX			;STARTADRESSE
	JP	C, ERROR	
	LD	(ARG1),HL	
	CALL	ASHEX			;ENDADRESSE
	JP	C, ERROR	
	LD	(ARG2),HL	
	CALL	ASHEX			;EINTRITTSPUNKT
	JR	NC, SAVE	
	LD	HL,RSTAR		;FEHLT,DESHALB RSTAR
SAVE:	LD	(ARG3),HL	
	CALL	GCOM	
	CALL	CINIT	
	LD	HL,SAVEE	
	PUSH	HL	
	LD	HL,SAVE0	
	PUSH	HL			;RETURN=>SAVE0
	PUSH	HL	
	LD	C,NL			;FILEANFANG
	LD	A,(FITY)	
	CP	A, ' '	
	JR	NZ, SAVE0	
	LD	A,'P'			;KEINE ANGABE
	LD	(FITY),A	
SAVE0:	LD	B,20	
SAVE1:	LD	A,0FFH			;SYNCHRCNZEICHEN

	CALL	CPO	
	DJNZ	SAVE1	
	LD	A,C	
	CALL	CPO			;NL ODER SYNCHRONZEICHEN
	LD	A,SOH			;START KOPF
	CALL	CPO	
;KOPF AUSGEBEN
;SOH/FILENAME/TT/AA/EE/SS/................/PS/STX
	LD	HL,FINA	
	LD	B,32	
	LD	C,0	
SAVE2:	LD	A,(HL)	
	CALL	CPO	
	LD	A,(HL)	
	ADD	A, C			;PRUEFSUMME
	LD	C,A	
	INC	HL	
	DJNZ	SAVE2	
	NEG		
	CALL	CPO			;PUEFSUMME
	LD	A,STX			;KOPF-ENDE
	CALL	CPO	
	LD	DE,(ARG1)		;ANF.ADR.
SAVE3:	LD	B,6	
SAVE4:	LD	A,0FFH			;SYNC.
	CALL	CPO	
	DJNZ	SAVE4	
	LD	HL,(ARG2)		;ENDADR.
	INC	HL	
	SBC	HL,DE			;BLOCKLAENGE BERECHNEN

	JR	Z, SAVE8		;FERTIG
	XOR	A	
	OR	H	
	JR	NZ, SAVE5	
	ADD	A, L	
	JP	P, SAVE6	
SAVE5:	LD	L,80H	
SAVE6:	LD	B,L			;BYTEZAEHLER
	LD	A,GS			;START BLOCK
	CALL	CPO	
	LD	A,B	
	LD	C,A	
	CALL	CPO			;BLOCKLAENGE
SAVE7:	LD	A,(DE)	
	CALL	CPO	
	LD	A,(DE)	
	INC	DE	
	ADD	A, C	
	LD	C,A	
	DJNZ	SAVE7	
	NEG		
	CALL	CPO			;PRUEFSUMME
	JR	SAVE3	
SAVE8:	LD	A,ETX	
	LD	C,0FFH			;2.AUFZEICHNUNG
	JP	CPO	
SAVEE:	LD	B,32	
SAVEF:	LD	A,0FFH	
	CALL	CPO	
	DJNZ	SAVEF	

	LD	A,EOT	
	JP	CPO	


;******************************
;* IN OUT                     *
;******************************

	DW	HEAD	
	DB	"IN"	
	NOP		
	CALL	ASHEX	
	LD	C,L	
	IN	A, (C)	
	JP	OUTH	

	DW	HEAD	
	DB	"OUT"	
	NOP		
	CALL	ASHEX			;PORTADRESSE HOLEN
	LD	C,L	
	CALL	ASHEX			;WERT HOLEN
	OUT	(C), L	
	RET		

;******************************
;* FILL                       *
;******************************

	DW	HEAD	

	DB	"FILL"	
	NOP		
	CALL	ASHEX	
	JP	C, ERROR	
	LD	(ARG1),HL	
	CALL	ASHEX	
	JP	C, ERROR	
	LD	(ARG2),HL	
	CALL	ASHEX	
	LD	C,L			;FUELLBYTE
	LD	HL,(ARG1)	
	LD	DE,(ARG2)	
	JR	NC, FILL1	
	LD	C,0			;FUELLBYTE 00 FESTLEGEN
FILL1:	LD	(HL),C	
	PUSH	HL	
	XOR	A	
	EX	DE,HL	
	SBC	HL,DE	
	LD	B,H	
	LD	C,L	
	POP	HL	
	LD	D,H	
	LD	E,L	
	INC	DE	
	LDIR		
	RET		


;******************************

;* MEMSIZE                    *
;******************************

	DW	HEAD	
	DB	"SIZE"	
	NOP		
	CALL	PRINT	
	DB	"SIZE:"	
	DB	0	
	LD	HL,(MSIZE)	
	CALL	OUTHL	
	CALL	PRINT	
	DB	" RAMTOP:"	
	DB	0	
	CALL	MEMCH			;RAMTEST
	CALL	OUTHL	
	LD	(MSIZE),HL	
	CALL	INHEX	
	RET	C	
	LD	(MSIZE),HL	
	RET		


;******************************
;* TESTPROGRAMME              *
;******************************

;NMI VEKTOR EINTRAGEN
	DW	HEAD	
	DB	"NMI"	

	NOP		
NMIV:	LD	HL,66H	
	LD	(HL),0C3H		;JMP
	INC	HL	
	LD	(HL),L(BREAK)	
	INC	HL	
	LD	(HL),H(BREAK)	
	RET		

BREAK:	CALL	UPUSH			;BEI NMI
	POP	HL			;PC
	LD	(USP),SP	
	LD	(UPC),HL	
	LD	SP,STACK	
	CALL	PRINT	
	DB	"BREAK AT "	
	DB	0	
	CALL	OUTHL	
	LD	HL,MAIN	
	PUSH	HL	
	RETN		

;CPU AUSRAEUMEN
UPUSH:	LD	(SSP),SP	
	LD	SP,HIF	
	PUSH	IY	
	PUSH	IX	
	EXX				;ERST ZWEITREGISTER
	EX	AF, AF'	
	PUSH	HL	

	PUSH	DE	
	PUSH	BC	
	PUSH	AF	
	EXX				;DANN HAUPTREGISTER
	EX	AF, AF'	
	PUSH	HL	
	PUSH	DE	
	PUSH	BC	
	PUSH	AF	
	LD	A,I	
	LD	(HIF),A	
	JR	UPOP1	

;CPU EINRAEUMEN
UPOP:	LD	(SSP),SP	
	LD	SP,UREG	
	LD	A,(HIF)	
	LD	I,A	
	POP	AF	
	POP	BC	
	POP	DE	
	POP	HL	
	EXX		
	EX	AF, AF'	
	POP	AF	
	POP	BC	
	POP	DE	
	POP	HL	
	POP	IX	
	POP	IY	

	EXX		
	EX	AF, AF'	
UPOP1:	LD	SP,(SSP)	
	RET		

	DW	HEAD	
	DB	"GO"	
	NOP		
	DEC	DE	
	CALL	ASHEX			;ADR.
	JR	C, GO1			;KEINE ADR

	PUSH	HL			;ADR. RETTEN
	CALL	ASHEX			;BREAKP.?
	JR	C, GO2			;KEIN BREAKPOINT

	LD	A,(BRKPT+1)	
	CP	A, H(START)		;IST BRKPT SCHON GESETZT?
	JR	Z, GO01			;NEIN
	PUSH	HL			;BREAKPOINT RETTEN
	LD	HL,(BRKPT)		;ALTER BRKPT
	LD	A,(HL)			;STEHT DA NOCH RST 38?
	CP	A, 0FFH	
	JR	NZ, GO0			;NEIN/ALSO KEIN ALTER BREAKPOINT
	LD	A,(BRKPT+2)		;AUSTAUSCHEN
	LD	(HL),A	
GO0:	POP	HL			;NEUER BRKPT ZURUECK
GO01:	LD	(BRKPT),HL		;NEUEN BRKPT SPEICHERN
	LD	A,(HL)			;BYTE RETTEN
	LD	(BRKPT+2),A	

	LD	(HL),0FFH		;RST38 EINTRAGEN
	LD	HL,38H	
	LD	(HL),0C3H		;JMP
	INC	HL	
	LD	(HL),L(BRK)	
	INC	HL	
	LD	(HL),H(BRK)	
GO2:	POP	HL	
	LD	SP,USTCK		;USERSTACK
	LD	DE,MAIN			;RUECKSPRUNG
	PUSH	DE	
	PUSH	HL			;SPRUNG ADR.
	JR	UPOP	
GO1:	CP	A, 'P'	
	JR	NZ, GO3	
	INC	DE	
	LD	A,(DE)	
	CP	A, 'C'	
	JP	NZ, ERROR	
	LD	HL,(UPC)	
	LD	SP,(USP)	
	PUSH	HL	
	JR	UPOP	
GO3:	LD	HL,(BRKPT)	
	LD	A,(HL)	
	CP	A, 0FFH	
	JP	NZ, ERROR	
	LD	A,(BRKPT+2)	
	LD	(HL),A	
	RET		



BRK:	CALL	UPUSH	
	POP	HL	
	DEC	HL			;ALTER PC
	LD	(USP),SP	
	LD	(UPC),HL	
	LD	SP,STACK	
	LD	A,(BRKPT+2)		;BYTE WIEDER EINTRAGEN
	LD	(HL),A	
	LD	HL,START		;BREAKPOINT LOESCHEN
	LD	(BRKPT),HL	
	LD	HL,MAIN	
	PUSH	HL	

REGDP:	CALL	PRINT	
	DB	" AF   BC   DE   HL   AF"	
	DB	27H	
	DB	"  BC"	
	DB	27H	
	DB	"  DE"	
	DB	27H	
	DB	"  HL"	
	DB	27H	
	DB	"  IX   IY  I    SP    PC"
	DB	NL	
	DB	0	
	LD	B,10	
	LD	IX,UREG	
REGD1:	LD	L,(IX)	

	LD	H,(IX+1)	
	CALL	OUTHL	
	LD	A,' '	
	CALL	CO	
	INC	IX	
	INC	IX	
	DJNZ	REGD1	
	LD	A,(HIF)	
	CALL	OUTH	
	CALL	PRINT	
	DB	"  "	
	DB	0	
	LD	HL,(USP)	
	CALL	OUTHL	
	CALL	PRINT	
	DB	"  "	
	DB	0	
	LD	HL,(UPC)	
	CALL	OUTHL	
	RET		
REGD:	JP	REGDP	

	DW	HEAD	
	DB	"REG"	
	NOP		
REG1:	CALL	FNEXT	
	JR	C, REGD			;WEIL CR
	LD	HL,RTAB	
	LD	BC,8	
	CPIR				;AFBCDEHL SUCHEN

	JR	NZ, REG4		;DOPPELREG.
	LD	BC,UREG-RTAB-1	
	ADD	HL,BC			;ADRESSE DES REG.
	INC	DE	
	LD	A,(DE)	
	CP	A, 27H			;STRICHREGISTER
	JR	NZ, REG2		;NEIN
	INC	DE	
	LD	A,8			;WEIL STRICHREGISTER
	ADD	A, L			;ADR KORRIGIEREN
	LD	L,A	
REG2:	PUSH	HL	
REG3:	CALL	ASHEX			;BYTE HOLEN
	LD	A,L	
	POP	HL	
	JR	C, REGD			;KEIN HEX
	LD	(HL),A			;EINTRAGEN
	JR	REG1	
REG4:	CP	A, 'I'			;DOPPELREGISTER
	JR	NZ, REG5	
	INC	DE	
	LD	A,(DE)	
	CP	A, 'X'	
	LD	HL,HIX			;IX REGISTER
	JR	Z, REG7	
	CP	A, 'Y'	
	INC	HL	
	INC	HL	
	JR	Z, REG7			;IY REGITER
	LD	HL,HIF			;INTERRUPTREGISTER

	JR	REG2	
REG5:	CP	A, 'P'	
	JR	NZ, REG6	
	INC	DE	
	LD	A,(DE)	
	CP	A, 'C'	
	JR	NZ, REGD		;FALSCHE EINGABE
	LD	HL,UPC			;PC
	JR	REG7	
REG6:	CP	A, 'S'	
	INC	DE	
	LD	A,(DE)	
	CP	A, 'P'	
	JR	NZ, REGD		;FALSCHE EINGABE
	LD	HL,USP			;STACKPOINTER
REG7:	PUSH	HL	
	INC	DE	
	CALL	ASHEX			;WORT HOLEN
	LD	B,H	
	LD	C,L	
	POP	HL	
	JR	C, REGD			;FALLS KEINE HEX-EINGABE
	LD	(HL),C			;EINTRAGEN
	INC	HL	
	LD	(HL),B	
	JR	REG1	

RTAB:	DB	"FACBEDLH"	



;******************************
;* HELP                       *
;******************************

	DW	HEAD	
	DB	"HELP"	
	NOP		
	LD	HL,0	
	LD	BC,0	
	LD	A,NL	
	CALL	CO	
HELP1:	CALL	PRINT	
	DB	"   "	
	DB	0	
HELP2:	LD	A,L(HEAD)	
	CPIR				;SUCHE NACH ED
	RET	NZ	
	LD	A,H(HEAD)	
	CP	A, (HL)			;FOLGT FF?
	JR	NZ, HELP2		;NEIN
	PUSH	HL	
	PUSH	BC	
	LD	B,16			;TEST,OB NACH SPAETESTENS
HELP3:	LD	A,(HL)			;16 ZEICHEN EIN NOP FOLGT
	INC	HL	
	OR	A	
	JR	Z, HELP4		;JA,AUSGABE
	DJNZ	HELP3	
	POP	BC	
	POP	HL	

	JR	HELP2	
HELP4:	POP	BC			;AUSGABE
	POP	HL	
HELP5:	INC	HL	
	DEC	BC	
	LD	A,(HL)	
	OR	A			;TEST ENDE
	JR	Z, HELP1	
	CALL	CO	
	JR	HELP5	



;******************************
;* READMC                     *
;******************************

	DW	HEAD	
	DB	"READ"	
	NOP		
	CALL	RINIT	
	CALL	GFITY	
	CALL	ASHEX	
	LD	DE,0	
	JR	C, READ1	
	EX	DE,HL	
READ1:	CALL	RI			;DOPPELPUNKT SUCHEN
	CP	A, 3AH	
	JR	NZ, READ1	
	LD	C,0			;PRUEFSUMME =0 SETZEN

	CALL	READ3			;BLOCKLAENGE

	OR	A			;ENDE?
	RET	Z			;FERTIG
	LD	B,A	
	CALL	READ3			;HI DER ADR.
	LD	H,A	
	CALL	READ3			;LO
	LD	L,A	
	LD	A,(FITY)	
	CP	A, 'A'	
	JR	NZ, REAl2	
	PUSH	BC	
	PUSH	DE	
	PUSH	HL	
	CALL	OUTHL	
	LD	A,' '	
	LD	(FITY),A	
	CALL	INHEX	
	POP	DE	
	JR	C, REA11	
	SBC	HL,DE	
	EX	(SP),HL	
REA11:	POP	HL	
	EX	DE,HL	
	POP	BC	
REAl2:	ADD	HL,DE			;ADR+OFFSET
	CALL	READ3	
READ2:	CALL	READ3			;DATEN
	LD	(HL),A	

	INC	HL	
	DJNZ	READ2	
	CALL	READ3			;PRUEFSUMMFE
	JR	Z, READ1		;OK
	CALL	PRINT	
	DB	"CHECKSUM ERROR "	
	DB	0	
	CALL	OUTHL	
	CALL	CI			;HALT BIS TASTE GEDRUECKT
	CP	A, 'Q'			;QUIT?
	RET	Z	;JA
	LD	A,NL	
	CALL	CO	
	JR	READ1	
READ3:	PUSH	DE			;BYTE VOM LESER
	CALL	RI	
	CALL	CNVBN	
	RLCA		
	RLCA		
	RLCA		
	RLCA		
	LD	D,A	
	CALL	RI	
	CALL	CNVBN	
	OR	D			;BYTE ZUSAMMENFUEGEN
	LD	D,A			;RETTEN
	ADD	A, C			;PRUEFSUMME
	LD	C,A			;NACH C ZURUECK
	LD	A,D	
	POP	DE	

	RET		

;******************************
;* CHECKSUM                   *
;******************************

	DW	HEAD	
	DB	"CHECKSUM"	
	NOP		
	CALL	ASHEX	
	JP	C, ERROR	
	PUSH	HL	
	CALL	ASHEX	
	EX	DE,HL	
	INC	DE			;ENDADRESSE+1
	POP	HL			;STARTADR.
	JP	C, ERROR	
CHECK:	LD	IX,0			;IX DIENT ALS AKKU
	LD	B,0	
CHCK1:	LD	C,(HL)	
	ADD	IX,BC			;SUMMIEREN
	INC	HL	
	PUSH	HL	
	XOR	A			;CY=0
	SBC	HL,DE			;ENDADRESSE ERRREICHT?
	POP	HL	
	JR	C, CHCK1		;NEIN,WEITER
	PUSH	IX			;FRGEBNIS
	POP	HL			;NACH HL FUER AUSGABE
	JP	OUTHL			;AUSGABE UND RETURN


;******************************
;* CALCULATE                  *
;******************************

	DW	HEAD	
	DB	"="	
	NOP		
	CALL	ASHEX	
	PUSH	HL	
	PUSH	HL	
	PUSH	HL	
	CALL	ASHEX	
	EX	DE,HL	
	POP	HL			;SUMMETAUSRECHNEN
	ADD	HL,DE			;
	CALL	PRINT			;UND AUSGEBEN
	DB	"SUM:"	
	DB	0	
	CALL	OUTHL	
	POP	HL			;DIFFERENZ AUSRECHNEN
	OR	A			;CY=O
	SBC	HL,DE	
	CALL	PRINT			;UND AUSGEBEN
	DB	"  DIF:"	
	DB	0	
	CALL	OUTHL	
	POP	HL	
	EX	DE,HL	
	OR	A	

	SBC	HL,DE	
	DEC	HL	
	DEC	HL	
	CALL	PRINT	
	DB	"  REL:"	
	DB	0	
	ADD	HL,HL			;TEST BEREICHS UEBERSCHREITUNG
	LD	A,H			;BEI RELATIVEN SPRUENGEN
	ADC	A, 0	
	JR	NZ, CALC1		;ZU WEIT
	LD	A,L	
	RRA				;/2
	JP	OUTH			;AKKU AUSGEBEN UND RETURN
CALC1:	CALL	PRINT			;WENN ZU WEIT
	DB	"**"	
	DB	0	
	RET		

;******************************
;* FIND                       *
;******************************

	DW	HEAD	
	DB	"FIND"	
	NOP		
FIND:	CALL	GFITY	
	CALL	ASHEX	
	PUSH	HL	
	CALL	ASHEX	
	CALL	FNEXT	

	LD	(TXTPT),DE		;BEGINN DER ZU SUCH. BYTES
	PUSH	HL			;ENDADRESSE RETTEN
	LD	A,(FITY)		;OPTION TESTEN UND BEFEHLSFOLGE ERZEUGEN
	LD	HL,FINCH		;ZEICHENKETTE
	LD	DE,DATA	
	LD	BC,12	
	CP	A, 'A'	
	JR	Z, FIND1	
	LD	HL,FINHX		;HEX
FIND1:	LDIR				;BEFEHLSFOLGE INS RAM LADEN
	POP	BC			;ENDADRESSE
	INC	BC	
	POP	HL			;STARUTADRESSE
FIND2:	LD	DE,(TXTPT)	
	PUSH	HL	
FIND3:	JP	DATA			;VARIABLES PGM AUSFUEHREN
FIND4:	CP	A, (HL)	
	INC	HL	
	JR	Z, FIND3		;GLEICH,WEITER
FIND7:	LD	A,C			;TEST OB ENDE
	SUB	L	
	LD	A,B	
	SBC	A,H	
	POP	HL	
	JR	NC, FIND6	
	RET		
FIND8:	LD	A,(DE)	
	CP	A, CR	
	JR	NZ, FIND7	
FIND5:	POP	HL	

	CALL	OUTHL			;ADRESSE AUSGEBEN
	CALL	PRINT	
	DB	"  "	
	DB	0	
FIND6:	INC	HL	
	JR	FIND2			;WEITERSUCHEN

FINCH:	LD	A,(DE)			;STRING SUCHEN
	INC	DE	
	CP	A, CR	
	JP	NZ, FIND4		;VERGLEICHEN
	JP	FIND5			;GEFUNDEN
FINHX:	PUSH	HL			;HEX SUCHEN
	CALL	ASHEX	
	LD	A,L	
	POP	HL	
	JP	NC, FIND4		;VERGLEICHEN
	JP	FIND8			;GEFUNDEN ??

;******************************
;* EOF                        *
;******************************

	DW	HEAD	
	DB	"EOF"	
	NOP		
EOFI:	LD	A,(EOFCH)	
	CALL	OUTH	
	CALL	INHEX	
	RET	C	

	LD	A,L	
	LD	(EOFCH),A	
	RET		

;******************************
;* POWER OFF                  *
;******************************

	DW	HEAD	
	DB	"OFF"	
	NOP		
OFF:	OUT	0, A	
	OUT	0, A	
	RET		

;******************************
;* ASNRI	              *
;******************************


	DW	HEAD	
	DB	"ASNRI=RI"	
	NOP		
RIRI:	LD	HL,RI1	
	JR	ASNRI	

	DW	HEAD	
	DB	"ASNRI=CRI"	
	NOP		
RICRI:	LD	HL,CRI1	

ASNRI:	LD	(RI+1),HL	
	RET		

	DW	HEAD	
	DB	"ASNRI=USR"	
	NOP		
	CALL	ASHEX	
	RET	C	
	JR	ASNRI	

MEMSI:	LD	A,(MSIZE+1)		;WIRD VON EXTERNEN PGM GENUTZT
	LD	B,A	
	LD	A,(MSIZE)	
	RET		

;EINFACHER RAMTEST
MEMCH:	LD	HL,-1			;START BEI 0
	LD	DE,SYSBG		;BIS SYSTEMBEGINN
MCH:	INC	HL	
	LD	A,(HL)	
	XOR	0FFH			;KOMPLEMENTIEREN
	LD	(HL),A	
	CP	A, (HL)	
	JR	NZ, MCH1	
	XOR	0FFH	
	LD	(HL),A	
	CP	A, (HL)			;WIEDER GLEICH?
	JR	NZ, MCH1		;NEIN
	PUSH	HL	
	SBC	HL,DE			;ENDE?

	POP	HL	
	JR	NZ, MCH			;NEIN,WEITER
MCH1:	DEC	HL	
	RET		

;ROUTINE FUER EXTERNE MONITORBENUTZUNG
EXT:	PUSH	HL	
	PUSH	BC	
	PUSH	AF	
	LD	HL,ETAB	
	LD	B,0	
	SLA	C			;C=C*2
	ADD	HL,BC	
	LD	A,(HL)	
	INC	HL	
	LD	H,(HL)	
	LD	L,A			;HL=ZIELADRESSE
	POP	AF	
	POP	BC	
	EX	(SP),HL			;ZIEL==>STACK,HL ZURUECK
	RET				;JMP


;******************************
;* GERAETEROUTINEN            *
;******************************


;KASSETTE INITIALISIEREN
CINIT:	LD	C,CSIOA	

	LD	B,8	
	LD	HL,CTAB	
	OTIR		
	LD	A,5	
	OUT	CTC2, A	
	LD	A,4	
	OUT	CTC2, A	
	RET		

CTAB:	DB	4	
	DB	4	
	DB	1	
	DB	40H	
	DB	3	
	DB	0C1H	
	DB	5	
	DB	0EAH	

;LOCHBANDLESEN INITIALISIEREN
RINIT:	LD	A,04FH	
	OUT	(CP1A), A	
	LD	A,0CFH	
	OUT	(CP1B), A	
	LD	A,1	
	OUT	(CP1B), A	
	LD	A,10H	
	OUT	(CP1B), A	
	RET		

;ZEICHEN VON LOCHBAND HOLEN

RI1:	LD	A,10H	
	OUT	(DP1B), A		;STARTINPULS
	XOR	A	
	OUT	(DP1B), A	
RI12:	CALL	SEOF	
	IN	A, DP1B	
	AND	A, 1	
	JR	NZ, RI12	
	IN	A, DP1A	
	AND	A, 7FH	
	JR	Z, RI1	
	RET		

;ZEICHEN VON KASSETTE HGL::N
CRI1:	CALL	SEOF	
	IN	A, CSIOA	
	AND	A, 1	
	JR	Z, CRI1	
	IN	A, DSIOA	
	RET		
;ZEICHEN AUF KASSETTE AUFZEICHNEN
CPO1:	OUT	DSIOA, A	
CPO11:	IN	A, CSIOA	
	AND	A, 4	
	JR	Z, CPO11	
	RET		

SEOF:	IN	A, KEYBD		;LESEN UNTERBRECHEN?
	CP	A, EOF	
	RET	NZ	

	POP	AF			;STACK KORRIGIEREN
	LD	A,(EOFCH)	
	RET		

;CONSOLSTATUSABFRAGE
CSTS:	IN	A, KEYBC	
	OR	A	
	RET	Z			;KEINE TASTE
	IN	A, KEYBD	
	CP	A, CR	
	JR	Z, CSTS	
	LD	(CSTSR),A	
	OR	0FFH	
	RET		

;TASTATUREINGABE
CI1:	LD	A,(CSTSR)	
	OR	A	
	JR	Z, CI11	
	XOR	A	
	LD	(CSTSR),A	
	IN	A, KEYBD	
	RET		
CI11:	IN	A, KEYBC		;AUF STEIGENDE FLANKE WARTEN
	OR	A	
	JR	NZ, CI11	
CI12:	IN	A, KEYBC	
	OR	A	
	JR	Z, CI12	
	IN	A, KEYBD	

	RET		

;BILDSCHIRMAUSGABE
CO1:	PUSH	HL	
	PUSH	DE	
	PUSH	BC	
	PUSH	AF	
	LD	HL,(CURS)		;HL=CURSOR
	LD	B,A	
	LD	A,80H			;CUSOR AUS
	XOR	(HL)	
	LD	(HL),A	
	LD	A,B	
	CP	A, NL+1			;STEUERZEICHEN?
	JR	NC, CRT5		;NEIN
	CP	A, NL			;NEUE ZEILE?
	LD	DE,CHPL			;ZEICHEN/ZEILE
	JR	NZ, CRT2		;NEIN,NICHT NL
	LD	A,L			;ZUM ZEILENANFANG ZURUECK
	AND	A, -CHPL	
	LD	L,A	
CRT1:	ADD	HL,DE			;LINEFEED
	JR	CRT7	
CRT2:	CP	A, CR	
	JR	NZ, CRT3	
	LD	A,L			;ZUM ZEILENANF. ZURUECK
	AND	A, -CHPL	
	LD	L,A	
	JR	CRT9	
CRT3:	CP	A, LF	

	JR	Z, CRT1			;LINEFEED AUSFUEHREN
	CP	A, CURL	
	JR	C, CRT5	
	JR	NZ, CRT10	
	DEC	HL			;CURSOR LINKS
CRT4:	LD	A,H			;TEST OB NOCH IM BILDSCHIRM
	CP	A, H(CRTBG)	
	JP	C, CRT15	
	JR	CRT9	
CRT5:	LD	(HL),A			;ZEICHEN NACH CRT
CRT6:	INC	HL			;CURSOR RECHTS
CRT7:	LD	A,H			;ROLLEN NOTWENDIG?
	CP	A, H(CRTEN)	
	JR	C, CRT9			;NEIN
	LD	DE,CRTBG	
	PUSH	HL	
	LD	HL,CRTBG+CHPL	
	LD	BC,CRTEN-CRTBG	
	LDIR		;ROLLEN
	LD	HL,CRTEN-CHPL	
	LD	B,CHPL	
	LD	A,' '	
CRT8:	LD	(HL),A			;LETZTE ZEILE LOESCHEN
	INC	HL	
	DJNZ	CRT8	
	POP	HL	
	LD	DE,CHPL			;CURSOR KORRIGIEREN
	OR	A	
	SBC	HL,DE	
CRT9:	LD	A,80H			;CURSOR AN

	XOR	(HL)	
	LD	(HL),A	
	LD	(CURS),HL	
	POP	AF	
	POP	BC	
	POP	DE	
	POP	HL	
	RET		
CRT10:	CP	A, CURR	
	JR	Z, CRT6	
	CP	A, CURU	
	JR	NZ, CRT11	
	OR	A			;CURSOR HOCH
	SBC	HL,DE	
	JR	CRT4	
CRT11:	CP	A, ESC	
	JR	NZ, CRT12	
	LD	A,(HL)			;INVERTIEREN
	XOR	80H	
	JR	CRT5	
CRT12:	CP	A, CLS	
	JR	NZ, CRT14	
CRT19:	LD	HL,CRTBG	
CRT13:	LD	(HL),' '		;LOESCHEN
	INC	HL	
	LD	A,H	
	CP	A, H(CRTEN)	
	JR	NZ, CRT13		;ANSCHLIESSEND HOME
	LD	A,HOME	
CRT14:	CP	A, HOME	

	JR	NZ, CRT5	
CRT15:	LD	HL,CRTBG	
	JR	CRT9	

;TABELLE FUER GERAETEZUWWEISUNG
ATAB:	DW	START-1			;MSIZE
	DB	EOT			;EOFCH
	DB	0			;CSTSR
	LD	A,C	
	JP	CO1			;LO
	LD	A,C	
	JP	CPO1			;PO
	LD	A,C	
	JP	CPO1			;CPO
	LD	A,C	
	JP	CO1			;CO
	JP	RI1	
	JP	CRI1	
	JP	CI1	
	DW	START	
	DB	0C3H	

ETAB:	DW	INHEX			;0
	DW	ASHEX			;1
	DW	CNVBN			;2
	DW	OUTH			;3
	DW	OUTHL			;4
	DW	PRINT			;5
	DW	INL			;6
	DW	INL00			;7

	DW	MEMO1			;8
	DW	MOVE			;9
	DW	READ1-3			;10 =0AH
	DW	LDEXT			;11 =0BH
	DW	SAEXT			;12 =0CH
	DW	OFF			;13 =0DH
	DW	RIRI			;14 =0EH
	DW	RICRI			;15 =0FH
	DW	CINIT			;16 =10H
	DW	RINIT			;17 =11H
	DW	FILL1			;18 =12H
	DW	NMIV			;19 =13H
	DW	UPUSH			;20 =14H
	DW	UPOP			;21 =15H
	DW	REGDP			;22 =16H
	DW	REG1			;23 =17H
	DW	CHECK			;24 =18H
	DW	FIND			;25 =19H
	DW	MEMCH			;26 =IAH



	;EJEC		
;******************************
;* VEREINBARUNGEN             *
;******************************

;PORTS:
POWOF:	EQU	0			;POWER OFF
KEYBD:	EQU	8			;TASTATURDATEN

KEYBC:	EQU	9			;TASTATURSTATUS 0FFH=GEDR./0=KEINE TASTE
BEPOF:	EQU	8			;SIGNALTON AUS
BEPON:	EQU	9			;AN
DP1A:	EQU	0CH			;12  PIO 1
CP1A:	EQU	0DH			;13
DP1B:	EQU	0EH			;14
CP1B:	EQU	0FH			;15
DP2A:	EQU	10H			;16  STEUERPORT LBL
CP2A:	EQU	11H			;17  BIT 0 STATUS,BIT 4 STARTIMPULS
DP2B:	EQU	12H			;18 LBL DATEN
CP2B:	EQU	13H			;19
CTCO:	EQU	14H			;20
CTC1:	EQU	15H			;21
CTC2:	EQU	16H			;22 KASSETTE
CTC3:	EQU	17H			;23
DSIOA:	EQU	18H			;24 KASSETTE
CSIOA:	EQU	19H			;25
DSIOB:	EQU	1AH			;26
CSIOB:	EQU	1BH			;27
;
CURL:	EQU	8			;CURSOR LINKS
CURR:	EQU	9			;RECHTS
CURD:	EQU	0AH			;10 ;RUNTER
CURU:	EQU	0BH			;11 ;HOCH
HOME:	EQU	0EH			;14
ESC:	EQU	1BH			;ESCAPE
NL:	EQU	1EH			;NEW LINE
LF:	EQU	0AH			;LINE FEED
CR:	EQU	0DH			;RETURN
CLS:	EQU	0CH			;BILDSCHIRM LOESCHEN

SOH:	EQU	1			;START KOPF
GS:	EQU	1DH			;GRUPPENTRENPdUNG
ETX:	EQU	03H			;END OF TEXT
EOT:	EQU	04H			;END OF TRANSMISSION
STX:	EQU	02H			;START OF TEXT
ERASE:	EQU	06H			;EINGABEZEILE LOESCHEN
EOF:	EQU	ETX			;END OF FILE
MEMB:	EQU	16			;BYTES/ZEILE (MEMORY)
MEML:	EQU	16			;ANZAHL ZEILEN (MEM)
CHPL:	EQU	64			;ZEICHEN/ZEILE (CRT)
HEAD:	EQU	0FFEDH			;SUCHCODE VOR KOMMANDO

	ORG	0FF00H	
;RAM BEREICH
STACK:	EQU	$-2	
USTCK:	EQU	$-64	
FINA:	DB	8	dup (?)		;FILENAME REGISTER
FITY:	DB	2	dup (?)		;FILETYP REGISTER
ARG1:	DB	2	dup (?)		;HEX EINGABEN
ARG2:	DB	2 	dup (?)		
ARG3:	DB	2 	dup (?)		
DATA:	DB	16	dup (?)		;ZUSATZREGISTER (FILE-INFO
INTV:	DB	32	dup (?)		;INTERRUPT VEKTOREN
TXTPT:	DB	2	dup (?)		;POINTER IPd TEXTPUFFER
TXTBU:	DB	81	dup (?)		;TEXTPUFFER
BULEN:	EQU	81			;PUFFERLAENGE
CURS:	DB	2	dup (?)		;CURSORPOSITION
HAF:	DB	2	dup (?)		;CPU-REGISTER
HBC:	DB	2 	dup (?)	
HDE:	DB	2 	dup (?)	
                  	 
HHL:	DB	2 	dup (?)	
AAF:	DB	2 	dup (?)	
ABC:	DB	2 	dup (?)	
ADE:	DB	2 	dup (?)	
AHL:	DB	2 	dup (?)	
HIX:	DB	2 	dup (?)	
HIY:	DB	2 	dup (?)	
HIF:	DB	2 	dup (?)	
UREG:	EQU	HAF	
USP:	DB	2 	dup (?)	
UPC:	DB	2 	dup (?)	
SSP:	DB	2	dup (?)		;ZWISCHENSPEICHER FUER SP
MSIZE:	DB	2	dup (?)		;HOECHSTER FREIER SPEICHERPLATZ
EOFCH:	DB	1	dup (?)		;EOF ZEICHEN
CSTSR:	DB	1	dup (?)		;CONSOLSTATUSZELLE
LOE:	DB	1	dup (?)		;LD A,C
LO:	DB	3	dup (?)		;JMP LIST-DEVICE
POE:	DB	1	dup (?)		;LD A,C
PO:	DB	3	dup (?)		;JMP PUNCH-DEVICE
CPOE:	DB	1	dup (?)		;LD A,C
CPO:	DB	3	dup (?)		;JMP KASSETTENAUSGABE
COE:	DB	1	dup (?)		;LD A,C
CO:	DB	3	dup (?)		;JMP CONSOLAUSGABE
RI:	DB	3	dup (?)		;JMP LBL
CRI:	DB	3	dup (?)		;JMP KASSETTENEINGABE
CI:	DB	3	dup (?)		;JMP CONSOLEINGABE
BRKPT:	DB	3	dup (?)		;BREAKPOINTMERKER

CRTBG:	EQU	0E800H			;BILDSCHIRMADR.
CRTEN:	EQU	0EE00H			;ENDE+1

MEMMO:	EQU	DATA			;DARSTELLMODE BEI MEMORY
SYSBG:	EQU	CRTBG	


	END		
